proc_reg <- function(ref_bio, ref_os, ref_peau, procrust, new_indiv) {
# ref_bio : les donn\'ees bio de la partie anatomique consid\'er\'ee
# ref_os : donn\'ees brutes osseuses de la partie anatomique consid\'er\'ee
# ref_peau : donn\'ees brutes cutan\'ees de la partie anatomique consid\'er\'ee
# procrust : un des jeux de donn\'ees Bouche, Nez, Oreilles, Yeux ci-dessus, correspondant \`a la partie anatomique
# new_indiv : l'individu inconnu

# Mettre tous les profils cutan\'es \`a taille centroide unitaire :
for (i in 1:nrow(procrust)) {
 procrust[i,] = scale_indiv(procrust[i,], 1)
}

# Mise en forme des donn\'ees bio :
new_bio = new_indiv[1, 1:3]
com_bio = ref_bio[noms_communs, ]
ncom_bio = ref_bio[!rownames(ref_bio) %in% noms_communs, ]
ref_bio2 = rbind(ncom_bio, com_bio) # donnees bio ordonn\'ees : individus communs / autres individus

# Construction de la BDD osseuse, et superposition procruste totale :
BDD = rbind(new_indiv[colnames(ref_os)], ref_os, communs[, colnames(ref_os)])
BDD = as.matrix(BDD)

nland=ncol(BDD)/3 # c'est le nombre de landmarks (1 landmark = 3 colonnes)
noms_array = list(as.character(1:nland), c("X", "Y", "Z"), rownames(BDD))
X = array(data=NA, dim=c(nland,3,nrow(BDD)), dimnames=noms_array) # tableau en 3D

for (k in 1:dim(X)[3]) {
 X[ , , k] = matrix(as.numeric(BDD[k, ]), ncol=dim(X)[2], byrow=TRUE)
}

res.gpa.com = procGPA(X, scale=TRUE, reflect=FALSE) # GPA sur toute la bdd de reference /!\ scale = TRUE or FALSE ?
x = res.gpa.com$rotated # coordonnees procrustes des individus sous forme d'un tableau 3D, pour les besoins du package shapes
for (i in 1:nrow(BDD)) {
 BDD[i, ] = as.numeric(t(x[,,i]))
}

# Calcul de la taille centroide osseuse de l'individu inconnu :
taille_os = csize(BDD[1,])

# Prediction taille centroide cutan\'ee de l'individu :
regtc = lm(CS_peau~CS_os+sexe+age, data=ref_bio) # +age et +CS_ autres parties anat
R = regtc$coef
N = c(1, taille_os, new_bio[1], new_bio[2])
taille_cut = R%*%as.numeric(N)

# Regression proprement dite :
pca = PCA(BDD, ncp=ncol(ref_os), graph=FALSE, scale=FALSE)$ind$coord # extraction des composantes principales osseuses
new = matrix(c(as.numeric(new_bio), pca[1,]), nrow=1) # nouvel individu
pca = pca[-1,]
pca = cbind(ref_bio2[,-c(4:5)], pca)
pca = as.matrix(pca)

r_anat = matrix(NA, nrow=4, ncol=ncol(ref_peau))
colnames(r_anat) = colnames(ref_peau)
rownames(r_anat) = c(rownames(new_indiv), "R^2", "R^2a", "Residual std. error")
for (j in 1:ncol(r_anat)) {
reg = lm(procrust[,j]~pca)
R = reg$coef
N = c(1, as.numeric(new))
r_anat[,j] = c(R%*%N, summary(reg)[[8]], summary(reg)[[9]], summary(reg)[[6]])
}

r_anat[1, ] = scale_indiv(r_anat[1, ], taille_cut)

return(r_anat)
}
