superpos1 <- function(Tab, K) {
# Tab : tableau de donnees des indiv. non-communs (\`a superposer sur les communs)
# K : coordonn\'ees procrustes cutan\'ees des 33 communs dans le rep\`ere de l'individu inconnu

land = colnames(Tab) # noms des landmarks cutan\'es
partcom = K[ , land] # on retient uniquement la partie anatomique retenue chez les communs (procrust\'es)
consensus = apply(partcom, MARGIN=2, FUN=mean) # individu moyen des 33, sur lequel on fera la superposition
consensus = matrix(consensus, ncol=3, byrow=TRUE)
tc = apply(consensus, MARGIN=2, FUN=mean) # centre de gravit\'e de l'individu inconnu

Resul = Tab # les resultats seront enregistr\'es ici
for (i in 1:nrow(Resul)) {
 Mi = matrix(as.numeric(Resul[i,]), ncol=3, byrow=TRUE)
 x = procOPA(consensus, Mi, scale=FALSE, reflect=FALSE)
 B = x$Bhat # \`a ce stade, B est la matrice des coordonn\'ees procrustes osseuses de l'individu commun num. i
 B = sweep(B, MARGIN=2, tc, FUN="+") # ici, B est translat\'e vers l'individu inconnu
 Resul[i,] = as.numeric(t(B)) # on enregistre ces coordonn\'ees dans la i-\`eme ligne de S
}
Resul = rbind(Resul, K[ , colnames(Tab)]) # jonction des individus communs et "non-communs"
return(Resul)
}