#define GPU_KERNEL_SOURCE

__kernel void reslice8b(int sw, int sh, int ss, __global unsigned char *buffer_src, int tw, int th, int ts, __global unsigned char *buffer_trg, __global float *matrix, float randVectorx,  float randVectory,  float randVectorz)
{
  size_t idx = get_global_id(0);

  if (idx<(tw*th*ts))
    {
      float svoxX, svoxY, svoxZ;
      int X, Y, Z;

      Z=(int)(((float)idx)/(tw*th));
      Y=(int)(((float)idx-Z*tw*th) / tw);
      X=idx-Z*tw*th-Y*tw;
  
      svoxX = X + randVectorx;
      svoxY = Y + randVectory;
      svoxZ = Z + randVectorz;
      
      float tmpX;
      float tmpY;
      float tmpZ;

      tmpX = matrix[0] * svoxX + matrix[1] * svoxY + matrix[2] * svoxZ + matrix[3];
      tmpY = matrix[4] * svoxX + matrix[5] * svoxY + matrix[6] * svoxZ + matrix[7];
      tmpZ = matrix[8] * svoxX + matrix[9] * svoxY + matrix[10] * svoxZ + matrix[11];
      
      X=tmpX;
      Y=tmpY;
      Z=tmpZ;
  
      if ( (X>=0) && (X<sw) && (Y>=0) && (Y<sh) && (Z>=0) && (Z<ss) )
	buffer_trg[idx] = buffer_src[ Z*sw*sh + Y*sw + X ];
    }
}  



__kernel void reslice16b(int sw, int sh, int ss, __global unsigned short *buffer_src, int tw, int th, int ts, __global unsigned short *buffer_trg, __global float *matrix, float randVectorx,  float randVectory,  float randVectorz)
{
  size_t idx = get_global_id(0);

  if (idx<(tw*th*ts))
    {
      float svoxX, svoxY, svoxZ;
      int X, Y, Z;

      Z=(int)(((float)idx)/(tw*th));
      Y=(int)(((float)idx-Z*tw*th) / tw);
      X=idx-Z*tw*th-Y*tw;
  
      svoxX = X + randVectorx;
      svoxY = Y + randVectory;
      svoxZ = Z + randVectorz;
      
      float tmpX;
      float tmpY;
      float tmpZ;

      tmpX = matrix[0] * svoxX + matrix[1] * svoxY + matrix[2] * svoxZ + matrix[3];
      tmpY = matrix[4] * svoxX + matrix[5] * svoxY + matrix[6] * svoxZ + matrix[7];
      tmpZ = matrix[8] * svoxX + matrix[9] * svoxY + matrix[10] * svoxZ + matrix[11];
      
      X=tmpX;
      Y=tmpY;
      Z=tmpZ;
  
      if ( (X>=0) && (X<sw) && (Y>=0) && (Y<sh) && (Z>=0) && (Z<ss) )
	buffer_trg[idx] = buffer_src[ Z*sw*sh + Y*sw + X ];
    }
}  

__kernel void reslice32b(int sw, int sh, int ss, __global unsigned int *buffer_src, int tw, int th, int ts, __global unsigned int *buffer_trg, __global float *matrix, float randVectorx,  float randVectory,  float randVectorz)
{
  size_t idx = get_global_id(0);

  if (idx<(tw*th*ts))
    {
      float svoxX, svoxY, svoxZ;
      int X, Y, Z;

      Z=(int)(((float)idx)/(tw*th));
      Y=(int)(((float)idx-Z*tw*th) / tw);
      X=idx-Z*tw*th-Y*tw;
  
      svoxX = X + randVectorx;
      svoxY = Y + randVectory;
      svoxZ = Z + randVectorz;
      
      float tmpX;
      float tmpY;
      float tmpZ;

      tmpX = matrix[0] * svoxX + matrix[1] * svoxY + matrix[2] * svoxZ + matrix[3];
      tmpY = matrix[4] * svoxX + matrix[5] * svoxY + matrix[6] * svoxZ + matrix[7];
      tmpZ = matrix[8] * svoxX + matrix[9] * svoxY + matrix[10] * svoxZ + matrix[11];
      
      X=tmpX;
      Y=tmpY;
      Z=tmpZ;
  
      if ( (X>=0) && (X<sw) && (Y>=0) && (Y<sh) && (Z>=0) && (Z<ss) )
	buffer_trg[idx] = buffer_src[ Z*sw*sh + Y*sw + X ];
    }
}  

